#include  "xml2note.h"

/*
<!ELEMENT grace EMPTY>
<!ATTLIST grace
    steal-time-previous CDATA #IMPLIED
    steal-time-following CDATA #IMPLIED
    make-time CDATA #IMPLIED
    slash %yes-no; #IMPLIED
>
<!--
	The cue and grace elements indicate the presence of
	cue and grace notes. The slash attribute for a grace
	note is yes for slashed eighth notes. The other grace
	note attributes come from MuseData sound suggestions.
	Steal-time-previous indicates the percentage of time
	to steal from the previous note for the grace note.
	Steal-time-following indicates the percentage of time
	to steal from the following note for the grace note.
	Make-time indicates to make time, not steal time; the
	units are in real-time divisions for the grace note. 
-->
	the units are in real-time divisions for the grace note. 
-->
*/

/*
  ($B0ULu$7$^$/$j!$%$%d%-%9%H(B)
<cue>, <grace> $B$O!$(Bcue, $BAu>~2;$NB8:_$r<($7$F$$$k!%(B
<grace slash="yes">$B$O!$<P@~$N$D$$$?H,J,2;Id$rI=8=$7$F$$$k!%(B
$B$=$NB>$N(B <grace> $B$NB0@-$O!$(BMuseData sound suggestions $B$KM3Mh$9$kI=5-$G$"$k!%(B
<grace steal-time-previous="$B?tCM(B"> $B$O!$Au>~2;$ND>A0$N2;Id$+$i(B steal $B$9$k(B($B:o$j<h$k(B)$B;~4V$N(B % $BCM$G$"$k!%(B
<grace steal-time-following="$B?tCM(B"> $B$O!$Au>~2;$ND>8e$N2;Id$+$i(B steal $B$9$k(B($B:o$j<h$k(B)$B;~4V$N(B % $BCM$G$"$k!%(B
<grace make-time="$B?tCM(B"> $B$O!$Au>~2;$N$?$a$KA^F~$9$k;~4V$G$"$k(B($B$=$NJ,!$DL>o$h$j$bA}$($k!)(B)$B!%(B
$B$=$N;~4V$NC10L$O!$(Bdivisions $BC10L$G$"$j!$Au>~2;$r1iAU$9$k$?$a$K$+$+$k<B:]$N;~4V$r(B divisions $BC10L$KD>$7$?;~4V$G$"$k!%(B
*/

/*
$B$A$J$_$K!$<j6a$J<-=q$K$O!$$3$&$"$j$^$9!%(B
$B?7D{(B $BI8=`2;3Z<-E5!'2;3ZG7M'<R(B, p.193, 1991.

$B%0%l!<%9!&%N!<%H(B
grace note[$B1Q(B]
$B>.$5$/0u:~$5$l$?2;Id$G!$$=$N;~2A$O>.@a$N%j%:%`$K?t$($i$l$J$$!%(B
$B$=$N;~2A$ONY@\$9$k2;Id$+$i8:$i$5$J$1$l$P$J$i$J$$!%(B
$B%0%l!<%9!&%N!<%H$,$?$/$5$s$"$j!$$=$l$,$R$H$D$N%0%k!<%W$r7A@.$7$F$$$k>l9g$O!$(B
$B$@$$$?$$$,>e5-$N5,B'$NNc30$H$J$k!%$=$l$i$O!$3ZIh$K>JN,$5$l$F$$$kC10L$N2;Id$R$H$D$rK~$?$9;~2A$r$H$k!%(B
$B%7%g%Q%s$O$=$l$r%+%G%s%D%!$HL>$E$1$?!%$=$N$H$-%0%l!<%9!&%N!<%H$N%j%:%`$O=@Fp@-$r$b$A!$(B
$B873J$JGo;R$K$O=>$o$J$$!%(B
*/



int grace(NOTE_NODE **part_cur,
	  int divi,  /*  XML $B$N(B divisions  */
	  double *type_duration,  /*
				    <type>quater</type> $B$+$i;;=P$7$?(B duration
				    $B$3$l$,(B xml_len, len $B$K$J$k(B  */
	  double *dur_duration,   /*
				    <duration>??</duration>$B$+$i;;=P$7$?(B duration
				    $B$3$l$H(B type_duration $B$+$i(B xml_len_diff, len_diff
				    $B$,;;=P$5$l$k(B */
	  double *pre_duration,    /*
				    $B$3$l$,(B xml_step $B$K$J$k(B($B%[%s%H!)(B)  */
	  double *now_time
	  )
{
  double grace_dur;
  NOTE_NODE *srch;


  grace_dur = 0.0;


  if(strcmp((*part_cur)->grace.type, "slash") == 0){
    /*    *pre_duration = - (*type_duration);  */
    *type_duration /= 4;
    *dur_duration = *type_duration;
    grace_dur = divi / 8.0;
  }else{
    grace_dur = divi / 8.0;
  }

  
  (*part_cur)->xml_len.beat = grace_dur;
  (*part_cur)->xml_len.meas = grace_dur;
  (*part_cur)->xml_len_diff.beat = 0;
  (*part_cur)->xml_len_diff.meas = 0;


/*   br_printf(5, "grace_dur: %5.3f\n", grace_dur); */

  srch = *part_cur;
  while(1){
    if(srch == NULL){  break; }
    if(strcmp((srch)->grace.type, "") == 0){
/*       br_printf(-1, "$BIaDL$N2;Id(B\n"); */
      (srch)->xml_step.beat -= grace_dur;
      (srch)->xml_step.meas -= grace_dur;
      (srch)->xml_len.beat -= grace_dur;
      (srch)->xml_len.meas -= grace_dur;
      (srch)->len.beat -= (grace_dur / divi);
      (srch)->len.meas -= (grace_dur / divi);
      break;
    }else{
      (srch)->org_xml_on_time.beat -= grace_dur;
      (srch)->org_xml_on_time.meas -= grace_dur;
    }
    srch = srch->pre;
  }

  *pre_duration = grace_dur;
  *now_time -= grace_dur;

  /*
  xmlDebugDumpNode(stdout, cur, 0);
  rc_printf(4, "<type>, <sound> direciton.dtd $B$rMxMQ$7$F(B duration $B$r@8@.$7$J$$$H$$$1$J$$(B\n");
  */

  return  EXIT_SUCCESS;
}
