/*  Time-stamp: <2004-07-15 15:51:27 >  */
/*
  MIDI in $B$+$i2;%$%Y%s%HF~NO$,$"$C$?$H$-$K!$(B
  $B$R$H$DA0$N2;%$%Y%s%H$r(B MIDI out $B=PNO$9$k(B
  Delay $B$C$]$$%W%m%0%i%`!%(B
*/

#include  "midi_io.h"
#include  "4ru.h"
#include  "signal_exit.h"
#include  "idle_func.h"


NOTE_NODE *note_top = NULL;
NOTE_NODE *note_bot = NULL;
NOTE_NODE *note_cur = NULL;
NOTE_NODE *note_alc = NULL;
NOTE_HEADER note_header_info;

EL *e_top = NULL;
EL *e_bot = NULL;
EL *e_cur = NULL;
EL *e_alc = NULL;
SMF_HEADER  smf_header_info;

int in_port = -2;

int loop;


#include  "dummy_var.h"  /*    $BJQ?t@k8@$N8e!$(Bmain $B$NA0$KCV$/!%(B  */


int main(void)
{
  int i;
  int j;
  double init_counter_val = 0;
  EL *pre_e_bot = NULL;
  int now_on_note;
  struct itimerval itval;


  /*  $B4X?t$X$N%]%$%s%?Dj5A(B  */
  int (*init_counter[1])(double qbpm, double init_counter_val) = {
    init_counter_tick_up
  };


#if 1  /*  Segmentation fault $B$N%P%0$rC5$9$H$-$O(B "#if 0"  */
  /*  Segmentation fault $B$,5/$-$?$H$-$K!$(BMIDI port $B$rJD$8$F$+$iMn$A$k!%(B  */
  signal(SIGSEGV, signal_exit);
   /*  Ctrl + C $B$GCfCG$5$l$?$H$-$K!$(BMIDI port $B$rJD$8$F$+$iMn$A$k!%(B  */
  signal(SIGINT, signal_exit);
#endif


  NOTEfile_read(NULL, &note_header_info);  /*  MIDI in buffering setting.  */

  br_printf(4, "\n select MIDI out port\n");
  open_midi_out( select_midi_out() );
  if(init_counter[0](DEFAULT_QBPM, init_counter_val) == EXIT_FAILURE){
    exit(0);
  }
  start_counter();

  loop = 300;
  itval.it_interval.tv_sec = 0;
  itval.it_interval.tv_usec = 100000;
  itval.it_value.tv_sec = 0;
  itval.it_value.tv_usec = 100000;
  signal(SIGVTALRM, idle_func);
  printf("ret: %d\n", setitimer(ITIMER_VIRTUAL, &itval, NULL));
  printf("%s\n", strerror(errno));


  now_on_note = 0x3c;

  while(loop){
    if((pre_e_bot != e_bot) && (e_bot != NULL) ){
      if(e_bot->ident == NOTE){
	if(e_bot->val2 != 0){  /*  MIDI in note on  */
	  e_cur = e_bot->pre;
	  while(1){
	    if(e_cur == NULL){  break; }
	    if( (e_cur->ident == NOTE) && (e_cur->val2 != 0) ){
	      midi_out(0, e_cur->stat, e_cur->val1, e_cur->val2, NULL);
	      now_on_note = e_cur->val1;
	      br_printf(6, "%06d msec: %02X %02X %02X:  %s\n",
			(int)e_cur->timestamp, e_cur->stat, e_cur->val1, e_cur->val2, e_cur->str);
	      break;
	    }
	    e_cur = e_cur->pre;
	  }
	}else{  /*  MIDI in note off  */
	  midi_out(0, 0x90, now_on_note, 0, NULL);
	  br_printf(6, "%06d msec: %02X %02X %02X:\n",
		    0, 0x90, now_on_note, 0);
	}
      }
      pre_e_bot = e_bot;
    }
  }

  puts("------ [Enter] key wait ------");
  getchar();


  e_cur = e_top;
  while(1){
    if(e_cur == NULL){  break; }
    printf("%06d msec: %02X %02X %02X:  %s\n",
	   (int)e_cur->timestamp, e_cur->stat, e_cur->val1, e_cur->val2, e_cur->str);
    if(e_cur == e_bot){
      break;
    }
   e_cur = e_cur->next;
  }
  close_note_midi_in();

  return 0;
}
