/*  Time-stamp: <2005-02-17 16:16:07 >  */
#include  "4ru.h"

int set_disp_str(NOTE_NODE *note_cur, EL *smf_cur)
{
  char spc_str[HEAD_STR_LEN];
  char str_tmp[HEAD_STR_LEN];
  int i;


  strcpy(spc_str, "");
  for(i = 0; i < (6 - (int)strlen(note_cur->str[0])); i++){
    strcat(spc_str, " ");
  }


  switch(note_cur->ident){
  case  NOTE:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %s%s",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    note_cur->str[0], spc_str);
    if(smf_cur->val2 != 0){
      sprintf(smf_cur->disp_str, "%s %3d", smf_cur->disp_str, smf_cur->val2);
    }else{
      sprintf(smf_cur->disp_str, "%s ---", smf_cur->disp_str);
    }

    break;
    
  case  REST:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %s%s%s%s %3d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(6), note_cur->str[0], br(-1), spc_str, (int)smf_cur->val2);
    break;
    
    
  case  BPM:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sBPM%s      %4.1f %3d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(4), br(-1), note_cur->val[0], 64 / (int)note_cur->val[1]);
    break;
    
  case  BEATTIME:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sBEATTIME%s  %5d  %2d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(4), br(-1), (int)note_cur->val[0], 64 / (int)note_cur->val[1]);
    break;
    
    
  case  DAMPER:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sDamper%s  %3d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(5), br(-1), (int)smf_cur->val2);
    break;
    
  case  SOSTENUTO:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sSostenuto%s%3d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(5), br(-1), (int)smf_cur->val2);
    break;
    
  case  SOFT:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sSoft%s    %3d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(5), br(-1), (int)smf_cur->val2);
    break;
    
  case  PAUSE:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sPAUSE%s%s %3d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(6), br(-1), str_tmp, (int)smf_cur->val1);
    break;
    
    
  case  BEAT:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %sBEAT%s  %d / %d",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    br(2), br(-1), smf_cur->nval1, smf_cur->nval2);
    break;


  case  WORDS:
  case  CRESC_DIM:
  case  DYNAMICS:
    for(i = 0; i < smf_cur->val2; i++){
      str_tmp[i] = smf_cur->data[i];
    }
    str_tmp[i] = '\0';

    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %s %s",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    (char *)str_tmp, smf_cur->str);
    break;

  case  O_TEXTSTR:
    sprintf(smf_cur->disp_str, 
	    "%10.3f  %2X %3d %3d: %s",
	    smf_cur->timestamp_for_disp,
	    smf_cur->stat, (int)smf_cur->val1, (int)smf_cur->val2,
	    smf_cur->str);
    break;


  default:
    br_printf(2, "%s: %d: note ident %d ɽʸꤷƤޤ", __FILE__, __LINE__,
	      note_cur->ident);
    break;
  }
  
  return  EXIT_SUCCESS;
  
}
