/*  Time-stamp: <04/07/15 17:44:37 noike>  */
#include  "4ru.h"


int set_timestamp(NOTE_NODE *note_cur, EL *smf_cur, int timescale, int on_off,
		  PERF_CTRL pctrl, double time_mul[4], ON_BIAS on_bias, double tick_rate)
{
  switch(timescale){
  case  T_BEAT:
    if(on_off == ON){  /*  Note-on   */
      smf_cur->timestamp =
	( (note_cur->on_time.beat + (note_cur->on_diff.beat * pctrl.on_diff_ratio) - on_bias.on_time.beat) )
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.beat + note_cur->on_diff.beat;
    }else{  /*  Note-Off   */
      smf_cur->timestamp =
	( (note_cur->on_time.beat + (note_cur->on_diff.beat * pctrl.on_diff_ratio) +
	   note_cur->len.beat + (note_cur->len_diff.beat * pctrl.len_diff_ratio)) - on_bias.on_time.beat)
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.beat + note_cur->on_diff.beat + note_cur->len.beat + note_cur->len_diff.beat;
    }
    break;
    
  case  T_REAL:
    if(on_off == ON){  /*  Note-on   */
      smf_cur->timestamp =
	( (note_cur->on_time.real + (note_cur->on_diff.real * pctrl.on_diff_ratio) - on_bias.on_time.real) )
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.real + note_cur->on_diff.real;
    }else{  /*  Note-Off   */
      smf_cur->timestamp =
	( (note_cur->on_time.real + (note_cur->on_diff.real * pctrl.on_diff_ratio) +
	   note_cur->len.real + (note_cur->len_diff.real * pctrl.len_diff_ratio)) - on_bias.on_time.real)
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.real + note_cur->on_diff.real + note_cur->len.real + note_cur->len_diff.real;
    }
    break;
    
  case  T_DELTA:
    if(on_off == ON){  /*  Note-on   */
      smf_cur->timestamp =
	( (note_cur->on_time.real + (note_cur->on_diff.real * pctrl.on_diff_ratio) - on_bias.on_time.real) )
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.real + note_cur->on_diff.real;
    }else{  /*  Note-Off   */
      smf_cur->timestamp =
	( (note_cur->on_time.real + (note_cur->on_diff.real * pctrl.on_diff_ratio) +
	   note_cur->len.real + (note_cur->len_diff.real * pctrl.len_diff_ratio)) - on_bias.on_time.real)
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.real + note_cur->on_diff.real + note_cur->len.real + note_cur->len_diff.real;
    }
    break;
    
    
  case  T_MEAS:
    if(on_off == ON){  /*  Note-on   */
      smf_cur->timestamp =
	( (note_cur->on_time.beat + (note_cur->on_diff.beat * pctrl.on_diff_ratio) - on_bias.on_time.beat) )
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.meas + note_cur->on_diff.meas;
    }else{  /*  Note-Off   */
      smf_cur->timestamp =
	( (note_cur->on_time.beat + (note_cur->on_diff.beat * pctrl.on_diff_ratio) +
	   note_cur->len.beat + (note_cur->len_diff.beat * pctrl.len_diff_ratio)) - on_bias.on_time.beat)
	* time_mul[timescale] + on_bias.timestamp;
      smf_cur->timestamp_for_disp =
	note_cur->on_time.meas + note_cur->on_diff.meas + note_cur->len.meas + note_cur->len_diff.meas;
    }
    break;
    
  default:
    break;
  }

  smf_cur->abs_delta = floor(smf_cur->timestamp / tick_rate + 0.5);  /*  ͼθ  */

  return  smf_cur->abs_delta;
}
