#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#ifdef __CYGWIN__
#include  <windows.h>
#include  <mmsystem.h>
#endif
#include  "midi_io.h"
#include  "disp_ctr.h"
#include  "NOTEfile.h"
#include  "flower.h"
#include  "get_wins.h"


static  double start_time;
static  double end_time;
static  double time_unit;



int gauge_disp(double timestamp)
{
  static int pre_x = 2;
  static int x;


  x = (int)(((timestamp - start_time) / time_unit) + 2);
  if(pre_x != x){
    if(x >= 2){
      xyrc_printf(x, GAUGE_Y, 1, "|");
      xyrc_printf(pre_x, GAUGE_Y, -1, "-");
      pre_x = x;
      fflush(stdout);
    }
  }else if(x == 2){
    xyrc_printf(x, GAUGE_Y, 1, "|");
  }    
  
  return EXIT_SUCCESS;
}



int simple_disp_init(MIDILIST *midi_top, NOTE_HEADER header_info, PERF_CTRL perf_ctrl, int out_port)
{
  MIDILIST *midi_cur;
  int column;
  int row;
  int i;

  midi_cur = midi_top;
  start_time = midi_cur->timestamp;
  while(midi_cur->next != NULL){
    midi_cur = midi_cur->next;
  }
  end_time = midi_cur->timestamp;
  get_winsize(&column, &row);

  time_unit = (end_time - start_time) / (double)(column - 2);
  
  cls();

  xy(1, 2);
  display_flower(column - 10, 10);

  xy(1, 1);
  rc_printf(5, "Title:");
  rc_printf(-1, " %s\n", header_info.title);

  rc_printf(5, "Composer:");
  rc_printf(-1, " %s\n", header_info.composer);

  rc_printf(5, "Arranger:");
  rc_printf(-1, " %s\n", header_info.arranger);

  rc_printf(5, "Performer:");
  rc_printf(-1, " %s\n", header_info.performer);

  rc_printf(5, "Generator:");
  rc_printf(-1, " %s\n", header_info.generator);

  rc_printf(5, "playnote:");
  if(strcmp(perf_ctrl.playnote[0], "") == 0){
    rc_printf(-1, " all\n");
  }else{
    for(i = 0; i < PLAYNOTE_NUM; i++){
      if(strcmp(perf_ctrl.playnote[i], "") == 0){
	break;
      }
      rc_printf(-1, " %s", perf_ctrl.playnote[i]);
    }
    rc_printf(-1, "\n");
  }

  rc_printf(5, "on_diff_ratio:");
  rc_printf(-1, ": %3.2f\n", perf_ctrl.on_diff_ratio);
  
  rc_printf(5, "len_diff_ratio:");
  rc_printf(-1, ": %3.2f\n", perf_ctrl.len_diff_ratio);
  
  rc_printf(5, "\"BEATTIME\":");
  if(perf_ctrl.ig_beattime == ON){
    rc_printf(-1, " ignore\n");
  }else{
    rc_printf(-1, " valid\n");
  }

  rc_printf(5, "\"BPM\":");
  if(perf_ctrl.ig_bpm == ON){
    rc_printf(-1, " ignore\n");
  }else{
    rc_printf(-1, " valid\n");
  }

  rc_printf(5, "Output Port:");
  rc_printf(-1, " %s\n", get_midi_out_name(out_port));

  xyrc_printf(1, GAUGE_Y, -1, "|");
  for(i = 2; i < column; i++){
    xyrc_printf(i, GAUGE_Y, -1, "-");
  }
  xyrc_printf(i, GAUGE_Y, -1, "|");

  cursor_off();
  fflush(stdout);

  return  EXIT_SUCCESS;
}
