/* Time-stamp: <2005-12-07 03:04:26 noike>  */
#include  "xml2note.h"
#include  "iconv_if.h"


int xml_read(char *filename, NOTE_NODE *part_top[PART_NUM], PART_INFO  part_info[PART_NUM], int *part_num,
	     xmlDoc **xml_top, NOTE_HEADER *note_header_info, char prog_name[STR_LEN],
	     int *re_divi, int default_vel[PART_NUM], ARTI_DUR *arti_dur, DRUM_DEF *drum_data)
{
  xmlNode *root;
  xmlNode *cur;
  char title[STR_LEN] = "";
  char composer[STR_LEN] = "";
  char generator[STR_LEN] = "";
  char encode_date[STR_LEN] = "";
  char rights[STR_LEN] = "";
  int inst_num[PART_NUM];   /*  ep[gɊ܂܂鐺̐  */
  int part_idx;
  double now_divi[PART_NUM];
  Z_BIAS m0;
  Z_BIAS m1;
  Z_BIAS m0_bias;
  NOTE_NODE *part_cur;
  int m_line_base;

  int i;



  xmlLineNumbersDefault(1);  /* xmlNode ɍsԍt@\ Parser ɒǉD
				xmlGetLineNo(cur) g悤ɂȂD
			     */

  m_line_base = -1;  /*  note `ł̐ʎq̃x[Xl("m0"  0)D
			 XML  Voice 1  m0 ɂȂCm_line_base = -1D  */

  if(fopen(filename, "r") == NULL){
    br_printf(2, "t@C %s J܂łD\n", filename);
    exit(EXIT_FAILURE);
  }

  *xml_top = xmlParseFile(filename);
  if(*xml_top == NULL) {
    br_printf(2, "%s ́C` XML (Well-formed XML) ł͂ȂłD\n", filename);
    exit(EXIT_FAILURE); 
  }

  /*Get the root element node */
  root = cur = xmlDocGetRootElement(*xml_top);
  while(cur != NULL){
    if (cur->type == XML_ELEMENT_NODE) {
      if(xmlStrcmp(cur->name, (const xmlChar *)"score-partwise") != 0){
	br_printf(2, "This is \"%s\" MusicXML.\n", cur->name);
	br_printf(2, "\"partwise\"  MusicXML ɂΉĂ܂D\n");
	xml_close(*xml_top);
	exit(EXIT_FAILURE);
      }else{
	break;
      }
    }
    cur = cur->next;
  }
  /*  now: cur == "score-partwise"  */

  cur = cur->children;
  /*  now: cur == ("score-partwise" ̈)  */

  for(part_idx = 0; part_idx < PART_NUM; part_idx++){
    if(part_top[part_idx] == NULL){
      part_top[part_idx] = NOTE_NODE_alloc();
    }
  }
  part_idx = 0;
  while(cur != NULL){
    if(cur->type == XML_ELEMENT_NODE){
      if(xmlStrcmp(cur->name, (const xmlChar *)"movement-title") == 0){
	/*  TITLE 擾  */
#ifdef ICONV
	strcpy(title, iconv_if(cur->children->content, "SHIFT-JIS", "UTF-8"));
#else
	strcpy(title, cur->children->content);
#endif
	
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"identification") == 0){
	cur = ident_analyze(cur, composer, generator, encode_date, rights);
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"part-list") == 0){
	cur = part_list_analyze(cur, part_info, part_num, inst_num);
#ifdef DEBUG2
	br_printf(5, "part_num: %d\n", *part_num);
	br_printf(5, "inst_num[%d].midi_ch: %d\n", *part_num - 1, part_info[*part_num - 1].midi_ch);
#endif
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"part") == 0){
	cur = part_analyze(cur, part_idx, part_top, now_divi, default_vel, arti_dur, &m_line_base, drum_data);
	part_idx++;
      }else{
	br_printf(3, "%s: %d: Skip: score-partwise: %s(XML line: %d)\n",
		  __FILE__, __LINE__, cur->name, xmlGetLineNo(cur));
	xmlDebugDumpNode(stdout, cur, 0);
/* 	exit(0); */
      }
    }
    cur = cur->next;
  }

  /*
  xml_close(*xml_top);
  */


  tie_cat(part_top, *part_num);

  part_sort(part_top, *part_num);


  velocity_apply(part_top, *part_num, default_vel);


/* Time-stamp: <2004-12-10 18:04:40 >  */
/*  for DEBUG  */
#if 0
  printf("------\n");
  for(i = 0; i < *part_num; i++){
    part_cur = part_top[i];
    while(1){
      if(part_cur->next == NULL){  break; }
      print_node(part_cur);
/*       printf("%d: %5.3f\n", i, part_cur->xml_on_time.beat); */
/*       printf("koko %d: %5.3f\n", i, part_cur->on_time.beat); */
      part_cur = part_cur->next;
    }
  }
#endif


  *re_divi = re_division(part_top, *part_num, *xml_top, -1);

  /*
    N̕CނɃVtgD
    ̂ƂCqLȂǂXLbvĂVtgȂƁC
    SMF ɂƂɏǗĂD
  */
  
  /* ÑoCAX߂  */
  m0.on_time = 0;
  m0.xml_on_time = 0;
  m0.org_xml_on_time = 0;
  m1.on_time = 0;
  m1.xml_on_time = 0;
  m1.org_xml_on_time = 0;

  for(i = 0; i < *part_num; i++){
    part_cur = part_top[i];
    while(part_cur != NULL){
/*       if(part_cur->ident == MEASURE){ */
      if(part_cur->ident == BAR){
	break;
      }
      part_cur = part_cur->next;
    }
    if(part_cur == NULL){  continue; }
      
    if(part_cur->val[0] == 0){
      part_cur = part_cur->next;
      while(part_cur != NULL){
	if(part_cur->ident == MEASURE){  /*  ȓsS߂ƊS߂̊Ԃ̏ߐ  */
	  m0.on_time = part_cur->on_time.beat;
	  m0.xml_on_time = part_cur->xml_on_time.beat;
	  m0.org_xml_on_time = part_cur->org_xml_on_time.beat;

	  part_cur = part_cur->next;

	  while(part_cur != NULL){
	    if(part_cur->ident == MEASURE){  /*  な̏ߐ̎̏ߐ  */
	      m1.on_time = part_cur->on_time.beat;
	      m1.xml_on_time = part_cur->xml_on_time.beat;
	      m1.org_xml_on_time = part_cur->org_xml_on_time.beat;
	      
	      break;
	    }
	    part_cur = part_cur->next;
	  }
	  
	  break;

	}
	part_cur = part_cur->next;
      }

      m0_bias.on_time = m1.on_time  - m0.on_time - m0.on_time;
      m0_bias.xml_on_time = m1.xml_on_time - m0.xml_on_time - m0.xml_on_time;
      m0_bias.org_xml_on_time = m1.org_xml_on_time - m0.org_xml_on_time - m0.org_xml_on_time;

      /*  Ñ̕oCAX𑫂  */
      part_cur = part_top[i];
      while(part_cur != NULL){
	if(part_cur->ident == BEAT){
	  break;
	}
	part_cur = part_cur->next;
      }
      while(part_cur != NULL){
	if(part_cur->ident != BEAT){
	  break;
	}
	part_cur = part_cur->next;
      }
      while(part_cur != NULL){
	part_cur->on_time.beat += m0_bias.on_time;
	part_cur->xml_on_time.beat += m0_bias.xml_on_time;
	part_cur->org_xml_on_time.beat += m0_bias.org_xml_on_time;
	
	part_cur = part_cur->next;
      }
    }
  }



#if 0
  for(i = 0; i < *part_num; i++){
    part_cur = part_top[i];
    while(1){
      if(part_cur->next == NULL){  break; }
/*       printf("%d: %5.3f\n", i, part_cur->xml_on_time); */
      printf("koko %d: %5.3f\n", i, part_cur->on_time.beat);
      part_cur = part_cur->next;
    }
  }
  exit(0);
#endif


  if(strcmp(title, "") != 0){
    strcpy(note_header_info->title, title);
  }
  if(strcmp(composer, "") != 0){
    strcpy(note_header_info->composer, composer);
  }

  sprintf(note_header_info->generator, "%s", prog_name);
  if(strcmp(generator, "") != 0){
    sprintf(note_header_info->generator, "%s(%s(%s))", note_header_info->generator, generator, rights);
  }


  add_attention();

  return  EXIT_SUCCESS;
}
