#include  "xml2note.h"


xmlNode *xmlnote_analyze(xmlNode *cur, NOTE_NODE **part_cur, int divisions,
			 double *now_time, double *pre_duration, int default_vel[PART_NUM], double bar_haku,
			 int beat_bunbo, ARTI_DUR *arti_dur, int m_line_base, int *m_line, int part_idx, DRUM_DEF *drum_data)
{
  char chartmp[STR_LEN];
  int inttmp;
  char notename[STR_LEN];
  double type_duration;  /*  <type>quater</type> Zo duration  */
  double dur_duration;   /* <duration>??</duration>Zo duration  */
  double normal_notes_dur;
  double actual_notes_dur;

  int i;


  /*  Warning ΍  */
  default_vel = default_vel;
  part_idx = part_idx;
  /*  Warning ΍􂱂܂  */

  /*  now: cur == "note"  */

  cur = cur->children;
  /*  now: cur == ("note" ̈̑w)  */

  type_duration = 0;
  dur_duration = 0;


  while(cur != NULL){
    if(cur->type == XML_ELEMENT_NODE){
      if(xmlStrcmp(cur->name, (const xmlChar *)"grace") == 0){	/*  <grace>  */
	if(xmlStrcmp(xmlGetProp(cur, "slash"), "yes") == 0){
	  strcpy((*part_cur)->grace.type, "slash");
	}else{
	  strcpy((*part_cur)->grace.type, "normal");
	}

	if(xmlGetProp(cur, "steal-time-previous") != NULL){
	  sscanf(xmlGetProp(cur, "steal-time-previous"), "%lf", &((*part_cur)->grace.steal_time_pre));
	  br_printf(3, "steal-time-previous %lf", (*part_cur)->grace.steal_time_pre);
	}

	if(xmlGetProp(cur, "steal-time-following") != NULL){
	  sscanf(xmlGetProp(cur, "steal-time-following"), "%lf", &((*part_cur)->grace.steal_time_following));
	  br_printf(3, "steal-time-following %lf", (*part_cur)->grace.steal_time_following);
	}

	if(xmlGetProp(cur, "make-time") != NULL){
	  sscanf(xmlGetProp(cur, "make-time"), "%lf", &((*part_cur)->grace.make_time));
	  br_printf(3, "make-time %lf", (*part_cur)->grace.make_time);
	}

	/* ԂCnow_time ́CȂĂ(͂)  */
	/*  steptime ̒߂Ĉق grace() ōsD  */

      }else if(xmlStrcmp(cur->name, (const xmlChar *)"chord") == 0){	/*  <chord>  */
	*now_time -= *pre_duration;
	/*
	(*part_cur)->pre->xml_step = 0;
	*/
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"rest") == 0){	/*  <rest>  */
	(*part_cur)->ident = REST;
	(*part_cur)->val[NOTE_NO] = -1;
	(*part_cur)->val[ON_VEL] = 0;
	strcpy((*part_cur)->str[0], "Rest");
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"pitch") == 0){	/*  <pitch>  */
	strcpy(notename, "");
	strcpy(chartmp, "");
	cur = cur->children;    /*  now: cur == ("pitch" ̈̑w)  */
	while(cur != NULL){
	  if(cur->type == XML_ELEMENT_NODE){
	    if(xmlStrcmp(cur->name, (const xmlChar *)"step") == 0){
	      sscanf(cur->children->content, "%s", notename);
	      if(strlen(chartmp) != 0){
		strcat(notename, chartmp);
		strcpy(chartmp, "");
		break;
	      }
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"alter") == 0){
	      sscanf(cur->children->content, "%d", &inttmp);
	      switch(inttmp){
	      case  1:
		strcat(notename, "#");
		break;

	      case  2:
		strcat(notename, "x");
		break;

	      case  -1:
		strcat(notename, "b");
		break;

	      case  -2:
		strcat(notename, "bb");
		break;
		
	      default:
		br_printf(2, "%s: %d: Unknown <alter>: note: %s (XML line: %d)\n",
			  __FILE__, __LINE__, cur->name, xmlGetLineNo(cur->next));
/* 		xmlDebugDumpNode(stdout, cur, 0); */
/* 		exit(EXIT_SUCCESS); */
		br_printf(2, "łȂ^O܂Cđs܂\n");
	      }
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"octave") == 0){
	      sscanf(cur->children->content, "%s", chartmp);
	      if(strlen(notename) != 0){
		strcat(notename, chartmp);
		strcpy(chartmp, "");
		break;
	      }
	    }
	  }

	  if(cur->next == NULL){
	    break;
	  }
	  cur = cur->next;
	}

	strcpy((*part_cur)->str[0], notename);
	notename_analyze(notename, *part_cur, drum_data);
/* 	(*part_cur)->val[ON_VEL] = default_vel[part_idx]; */
	cur = cur->parent;  /*  now: cur == "pitch"  */
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"duration") == 0){	/*  <duration>  */
	sscanf(cur->children->content, "%lf", &dur_duration);
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"voice") == 0){	/*  <voice>  */
	sscanf(cur->children->content, "%d", &inttmp);
/* 	sprintf((*part_cur)->str[1], "m%d", inttmp - 1); */
	(*m_line) = m_line_base + inttmp;
	sprintf((*part_cur)->str[1], "m%d", (*m_line));
	(*part_cur)->voice = inttmp;
	/*  FVeB́Cvelocity_apply() ł邱ƂɂD  */

/* 	(*part_cur)->val[ON_VEL] = default_vel[(*part_cur)->voice - 1]; */
/* 	printf("%d: %d\n", (*part_cur)->voice - 1, (int)(*part_cur)->val[ON_VEL]); */
/* 	printf("%d: %d\n", (*part_cur)->voice - 1, default_vel[(*part_cur)->voice - 1]); */
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"type") == 0){	/*  <type>  */
	/*  <grace> ŎgH  */
	type_duration = type2dur(cur->children->content, divisions, bar_haku);
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"dot") == 0){	/*  <dot>  */
	type_duration *= 1.5;
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"tie") == 0){	/*  <tie>  */
	if(xmlStrcmp(xmlGetProp(cur, "type"), "start") == 0){
	  (*part_cur)->tie_start = ON;
	}else if(xmlStrcmp(xmlGetProp(cur, "type"), "stop") == 0){
	  (*part_cur)->tie_stop = ON;
	}else{
	  br_printf(2, "%s: %d: Unknown tie type: note: %s (XML line: %d)\n",
		    __FILE__, __LINE__, cur->name, xmlGetLineNo(cur->next));
/* 	  xmlDebugDumpNode(stdout, cur, 0); */
	}
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"staff") == 0){	/*  <staff>  */
	sscanf(cur->children->content, "%d", &((*part_cur)->staff));
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"accidental") == 0){  /*  <accidental>  */
	;  /*  sharp Ƃ natural ƂāCȂƂȂH  */
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"notations") == 0){  /*  slur, fingering Ȃǂ͂  */
	notations_analyze(cur, part_cur);
      }else if(xmlStrcmp(cur->name, (const xmlChar *)"time-modification") == 0){  /*  OAȂǂ͂  */
	cur = cur->children;
	while(cur != NULL){
	  if(xmlStrcmp(cur->name, (const xmlChar *)"actual-notes") == 0){
	    sscanf(cur->children->content, "%lf", &actual_notes_dur);
	  }else if(xmlStrcmp(cur->name, (const xmlChar *)"normal-notes") == 0){
	    sscanf(cur->children->content, "%lf", &normal_notes_dur);
	  }
	  if(cur->next == NULL){
	    break;
	  }
	  cur = cur->next;
	}
	cur = cur->parent;
	type_duration = type_duration * normal_notes_dur / actual_notes_dur;
      }
      /*
	}else{	br_printf(3, "%s: %d: Skip: note: %s (XML line: %d)\n",
	__FILE__, __LINE__, cur->name, xmlGetLineNo(cur->next));
	xmlDebugDumpNode(stdout, cur, 0);
	}
      */
    }
    if(cur->next == NULL){
      break;
    }
    cur = cur->next;
  }



  /*  {IɁC<type> Ō܂鎞Ԃ̉ւ step time ɂȂ  */
  (*pre_duration) = type_duration;

  cur = cur->parent;  /*  now: cur == "note"  */

  /*  on_time  re_division.c Őݒ肷D  */

  /*  CɕtLނɂ len_diff ω  */
  if(strcmp((*part_cur)->grace.type, "") != 0){
    /*  grace() ̒ŁC̉Cxg̎ԏ̂ŁCɒӂ邱  */
    grace(part_cur, divisions, &type_duration, &dur_duration, pre_duration, now_time);
  }else if(dur_duration != type_duration){
    (*part_cur)->xml_len.beat = dur_duration;
    (*part_cur)->xml_len.meas = dur_duration;
    (*part_cur)->xml_len_diff.beat = dur_duration - type_duration;
    (*part_cur)->xml_len_diff.meas = dur_duration - type_duration;
  }else{
    (*part_cur)->xml_len.beat = type_duration;
    (*part_cur)->xml_len.meas = type_duration;
    (*part_cur)->xml_len_diff.beat = 0;
    (*part_cur)->xml_len_diff.meas = 0;
  }



  for(i = 0; i < SLUR_NUM; i++){
    switch((*part_cur)->notations.slur[i].type){
    case START:
    case STOP:
    case CONT:
      (*part_cur)->xml_len_diff.beat =
	((*part_cur)->xml_len.beat * arti_dur->slur[(*part_cur)->notations.slur[i].type]) - (*part_cur)->xml_len.beat;
      (*part_cur)->xml_len_diff.meas =
	((*part_cur)->xml_len.meas * arti_dur->slur[(*part_cur)->notations.slur[i].type]) - (*part_cur)->xml_len.meas;
      break;

    case  NO_INFO:
      break;
    }
  }


  if(strcmp((*part_cur)->notations.artic.name, "staccato") == 0){
    (*part_cur)->xml_len_diff.beat =
      ((*part_cur)->xml_len.beat * arti_dur->staccato) - (*part_cur)->xml_len.beat;
    (*part_cur)->xml_len_diff.meas =
      ((*part_cur)->xml_len.meas * arti_dur->staccato) - (*part_cur)->xml_len.meas;
  }


  if(xmlGetProp(cur, "dynamics") != NULL){
    sscanf(xmlGetProp(cur, "dynamics"), "%lf", &((*part_cur)->val[1]));
  }
  if(xmlGetProp(cur, "attack") != NULL){
    sscanf(xmlGetProp(cur, "attack"), "%lf", &((*part_cur)->xml_on_diff.beat));
  }
  if(xmlGetProp(cur, "release") != NULL){
    sscanf(xmlGetProp(cur, "release"), "%lf", &((*part_cur)->xml_len_diff.beat));
  }

  if(xmlGetProp(cur, "end-dynamics") != NULL){
    sscanf(xmlGetProp(cur, "end-dynamics"), "%lf", &((*part_cur)->val[2]));
  }

  (*part_cur)->on_diff.beat = ((*part_cur)->xml_on_diff.beat / divisions);
  (*part_cur)->on_diff.beat = (*part_cur)->on_diff.beat * (beat_bunbo / 4.0);

  (*part_cur)->len.beat = ((*part_cur)->xml_len.beat / divisions);
  (*part_cur)->len.beat = (*part_cur)->len.beat * (beat_bunbo / 4.0);
  
  (*part_cur)->len_diff.beat = (*part_cur)->xml_len_diff.beat / divisions;
  (*part_cur)->len_diff.beat = (*part_cur)->len_diff.beat * (beat_bunbo / 4.0);

  return cur;
}

/*    note.dtd p

<!--
	The position and printout entities are based on MuseData
	print suggestions and are defined in common.dtd.
	
	The dynamics and end-dynamics attributes reflect MIDI's
	Note On and Note Off velocities, respectively. They are
	expressed in terms of percentages of a standard MIDI
	forte volume of 90. The attack and release attributes
	are used to alter the staring and stopping time of the
	note from when it would otherwise occur based on the 
	flow of durations - information that is specific to a
	performance. They are expressed in terms of divisions,
	either positive or negative. The pizzicato attribute
	comes from MuseData sound suggestions. It is used when
	just this note is sounded pizzicato, vs. the pizzicato
	and arco elements.
-->
<!ATTLIST note
    %position; 
    %printout;
    dynamics CDATA #IMPLIED
    end-dynamics CDATA #IMPLIED
    attack CDATA #IMPLIED
    release CDATA #IMPLIED
    pizzicato %yes-no; #IMPLIED
>

4R dlł́C<note> ̎̑

dynamics:
  ŌFVeBl̂܂܋LqD
  
end-dynamics:
  FVeBl̂܂܋LqD

ƂĂ邱ƂɒӁDattack, release ɂẮC

attack:
  Ō̐KŷꎞԂCdivision PʂŋLqD

release:
  ̐KŷꎞԂCdivision PʂŋLqD

łCMusicXML ̒`ƓłD

܂Cxml2note ł́C
Xebv^C <type></type> C
Q[g^C <duration>l</duration> 
ZoĂD

<type>, <duration> w <note> Ƃ̎w肪HႤƂ́C
<note> ̂قLƂȂD

*/
